package com.ozs.common.constant;

import com.ozs.common.core.domain.entity.SysUser;
import com.ozs.common.core.domain.model.LoginUser;
import com.ozs.common.utils.ServletUtils;
import com.ozs.common.utils.ip.AddressUtils;
import com.ozs.common.utils.ip.IpUtils;
import eu.bitwalker.useragentutils.UserAgent;
import io.jsonwebtoken.Claims;

import java.util.HashMap;
import java.util.Map;

/**
 * 通用常量信息
 *
 * @author ruoyi
 */
public class Constants {
    /**
     * UTF-8 字符集
     */
    public static final String UTF8 = "UTF-8";
    public final static Map<String, LoginUser> map = new HashMap<>();

    /**
     * GBK 字符集
     */
    public static final String GBK = "GBK";

    /**
     * www主域
     */
    public static final String WWW = "www.";

    /**
     * http请求
     */
    public static final String HTTP = "http://";

    /**
     * https请求
     */
    public static final String HTTPS = "https://";

    /**
     * 通用成功标识
     */
    public static final String SUCCESS = "0";

    /**
     * 通用失败标识
     */
    public static final String FAIL = "1";

    /**
     * 登录成功
     */
    public static final String LOGIN_SUCCESS = "Success";

    /**
     * 注销
     */
    public static final String LOGOUT = "Logout";

    /**
     * 注册
     */
    public static final String REGISTER = "Register";

    /**
     * 登录失败
     */
    public static final String LOGIN_FAIL = "Error";

    /**
     * 验证码有效期（分钟）
     */
    public static final Integer CAPTCHA_EXPIRATION = 2;

    /**
     * 令牌
     */
    public static final String TOKEN = "token";

    /**
     * 令牌前缀
     */
    public static final String TOKEN_PREFIX = "Bearer ";

    /**
     * 令牌前缀
     */
    public static final String LOGIN_USER_KEY = "login_user_key";

    /**
     * 用户ID
     */
    public static final String JWT_USERID = "userid";

    /**
     * 用户名称
     */
    public static final String JWT_USERNAME = Claims.SUBJECT;

    /**
     * 用户头像
     */
    public static final String JWT_AVATAR = "avatar";

    /**
     * 创建时间
     */
    public static final String JWT_CREATED = "created";

    /**
     * 用户权限
     */
    public static final String JWT_AUTHORITIES = "authorities";

    /**
     * 资源映射路径 前缀
     */
    public static final String RESOURCE_PREFIX = "/profile";

    /**
     * RMI 远程方法调用
     */
    public static final String LOOKUP_RMI = "rmi:";

    /**
     * LDAP 远程方法调用
     */
    public static final String LOOKUP_LDAP = "ldap:";

    /**
     * LDAPS 远程方法调用
     */
    public static final String LOOKUP_LDAPS = "ldaps:";

    /**
     * 定时任务白名单配置（仅允许访问的包名，如其他需要可以自行添加）
     */
    public static final String[] JOB_WHITELIST_STR = {"com.ozs"};

    /**
     * 定时任务违规的字符
     */
    public static final String[] JOB_ERROR_STR = {"java.net.URL", "javax.naming.InitialContext", "org.yaml.snakeyaml",
            "org.springframework", "org.apache", "com.ozs.common.utils.file", "com.ozs.common.config"};

    // 項目屬性
    public static final String SYS_PROJECT_ATTR = "sys_project_attr";

    // 項目类型(添加)
    public static final String SYS_PROJECT_TYPE_AD = "sys_project_type_ad";
    // 項目类型(审核)
    public static final String SYS_PROJECT_TYPE = "sys_project_type";

    // 预算科目
    public static final String SYS_BUDGET_ACCOUNT = "budget_account";

    // 采购服务站
    public static final String PURCHASE_SERVICES = "purchase_services";


    // 需求单位
    public static final String DEMAND_UNIT = "demand_unit";
    // 采购管理部门
    public static final String PURCHASING_MANAGEMENT = "purchasing_management";
    // 采购办
    public static final String PROCUREMENT_OFFICE = "procurement_office";

    // 项目状态
    public static final String SYS_PROJECT_STATUS = "sys_project_status";
    // 报警状态
    public static final String PROJECT_WARN_STATUS = "project_warn_status";
    // 单位性质
    public static final String SYS_COMPANY_NATURE = "sys_company_nature";

}
