package com.ozs.base.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.ozs.base.domain.vo.BaseExpertVo;
import com.ozs.common.vo.BaseDto;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.joda.time.DateTime;

import java.util.Date;

@Data
@TableName("base_expert")
public class BaseExpert extends BaseDto {

    /**
     * 主键ID
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 专家名称
     */
    @ApiModelProperty(value = "专家名称")
    @TableField("expert_name")
    private String expertName;

    /**
     * 专家类型
     */
    @ApiModelProperty(value = "专家类型，多个使用英文逗号分隔")
    @TableField("expert_type")
    private String expertType;

    /**
     * 专家性别
     */
    @ApiModelProperty(value = "专家性别")
    @TableField("expert_gender")
    private String expertGender;

    /**
     * 出生年月
     */
    @JsonFormat(pattern = "yyyy-MM")
    @ApiModelProperty(value = "出生年月")
    @TableField("expert_date_birth")
    private String expertDateBirth;

    /**
     * 联系方式
     */
    @ApiModelProperty(value = "联系方式")
    @TableField("expert_tel")
    private String expertTel;

    /**
     * 专业类型
     */
    @ApiModelProperty(value = "专业类型，多个使用英文逗号分隔")
    @TableField("major_type")
    private String majorType;

    /**
     * 单位信息
     */
    @ApiModelProperty(value = "单位信息")
    @TableField("unit_information")
    private String unitInformation;

    /**
     * 专业等级
     */
    @ApiModelProperty(value = "专业等级")
    @TableField("major_grade")
    private String majorGrade;

    /**
     * 采购品种
     */
    @ApiModelProperty(value = "采购品种，多个使用英文逗号分隔")
    @TableField("variety_purchase")
    private String varietyPurchase;

    /**
     * 职称
     */
    @ApiModelProperty(value = "职称")
    @TableField("professional_title")
    private String professionalTitle;

    /**
     * 状态 黑白名单
     */
    @ApiModelProperty(value = "状态 黑白名单")
    @TableField("status")
    private String status;

    /**
     * 所在区域
     */
    @ApiModelProperty(value = "所在区域（行政区域表的code）")
    @TableField("local_area")
    private String localArea;

    /**
     * 身份证号
     */
    @ApiModelProperty(value = "身份证号")
    @TableField("id_number")
    private String idNumber;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    @TableField("created")
    private String created;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @TableField("create_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    @TableField("updated")
    private String updated;

    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    @TableField("update_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;
}
