package com.ozs.base.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.ozs.common.annotation.Excel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

@Data
@TableName("base_professional")
public class BaseProfessional {

    /**
     * 主键ID
     */
    @ApiModelProperty(value = "id")
    @TableId(type = IdType.AUTO)
    private Integer id;

    /**
     * 品目名称
     */
    @Excel(name = "品目名称")
    @ApiModelProperty(value = "品目名称")
    @TableField("professional_name")
    private String professionalName;

    /**
     * 编码
     */
    @Excel(name = "编码")
    @ApiModelProperty(value = "编码")
    @TableField("professional_code")
    private String professionalCode;

    /**
     * 说明
     */
    @Excel(name = "说明")
    @ApiModelProperty(value = "说明")
    @TableField("purchase_state")
    private String purchaseState;

    /**
     * 一级分类
     */
    @Excel(name = "一级分类")
    @ApiModelProperty(value = "一级分类")
    @TableField("professional_grade")
    private String professionalGrade;

    /**
     * 父级编码
     */
    @Excel(name = "父级编码")
    @ApiModelProperty(value = "父级编码")
    @TableField("parent_code")
    private String parentCode;
}
