package com.ozs.base.domain.vo;


import com.fasterxml.jackson.annotation.JsonFormat;
import com.ozs.common.vo.PageVo;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;

@Data
public class BaseExpertVo {

    /**
     * 查询抽取专家列表条件：项目名称,开始时间,结束时间
     */
    private String projectName;
    private Date startTime;
    private Date endTime;

    /**
     * 主键ID
     */
    @ApiModelProperty(value = "id")
    private Integer id;

    /**
     * 专家名称
     */
    @ApiModelProperty(value = "专家名称")
    private String expertName;

    /**
     * 专家类型
     */
    @ApiModelProperty(value = "专家类型，多个使用英文逗号分隔")
    private String expertType;

    /**
     * 专家类型名
     */
    @ApiModelProperty(value = "专家类型名，多个使用英文逗号分隔")
    private String expertTypeName;

    /**
     * 专家性别
     */
    @ApiModelProperty(value = "专家性别")
    private String expertGender;

    /**
     * 出生年月
     */
    @JsonFormat(pattern = "yyyy-MM")
    @ApiModelProperty(value = "出生年月")
    private String expertDateBirth;

    /**
     * 联系方式
     */
    @ApiModelProperty(value = "联系方式")
    private String expertTel;

    /**
     * 专业类型
     */
    @ApiModelProperty(value = "专业类型，多个使用英文逗号分隔")
    private String majorType;

    /**
     * 专业类型名
     */
    @ApiModelProperty(value = "专业类型名，多个使用英文逗号分隔")
    private String majorTypeName;

    /**
     * 单位信息
     */
    @ApiModelProperty(value = "单位信息")
    private String unitInformation;

    /**
     * 专业等级
     */
    @ApiModelProperty(value = "专业等级")
    private String majorGrade;

    /**
     * 采购品种
     */
    @ApiModelProperty(value = "采购品种，多个使用英文逗号分隔")
    private String varietyPurchase;

    /**
     * 采购品种名
     */
    @ApiModelProperty(value = "采购品种名，多个使用英文逗号分隔")
    private String varietyPurchaseName;

    /**
     * 职称
     */
    @ApiModelProperty(value = "职称")
    private String professionalTitle;

    /**
     * 状态 黑白名单
     */
    @ApiModelProperty(value = "状态 黑白名单")
    private String status;

    /**
     * 所在区域
     */
    @ApiModelProperty(value = "所在区域（行政区域表的code）")
    private String localArea;
    private List<String> localAreaList;

    /**
     * 所在区域
     */
    @ApiModelProperty(value = "所在区域名(省/市/县)")
    private String localAreaName;

    /**
     * 身份证号
     */
    @ApiModelProperty(value = "身份证号")
    private String idNumber;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String created;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updated;

    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;
    /**
     * 当前记录起始索引
     */
    @ApiModelProperty("页数")
    private Long pageNum;
    /**
     * 每页显示记录数
     */
    @ApiModelProperty("页大小")
    private Long pageSize;

}
