package com.ozs.base.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ozs.common.annotation.Excel;
import com.ozs.common.constant.ModularConstans;
import com.ozs.common.vo.PageVo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotEmpty;
import java.util.Date;

@ApiModel(value = "BaseNoticePageReqVo", description = ModularConstans.notice + "分页查询实体")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class BaseNoticePageReqVo extends PageVo {

    @ApiModelProperty("公告标题")
    private String title;

    @ApiModelProperty("项目名称")
    private String noticeName;
    // 开始时间
    @ApiModelProperty("开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date startTime;

    // 结束时间
    @ApiModelProperty("结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date entTime;

    /**
     * 公告类型
     */
    @ApiModelProperty("公告类型")
    private Long type;

    private Long deptId;

    private Boolean isAdmin;

    private boolean roleFlay;

}
