package com.ozs.home.domain;


import com.fasterxml.jackson.annotation.JsonFormat;
import com.ozs.common.core.domain.BaseEntity;
import io.swagger.annotations.ApiModel;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import java.util.Date;

/**
 * 首页公告
 * @author Administrator
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@ApiModel("首页公告")
@Table(name = "home_notice")
public class HomeNotice extends BaseEntity {

    /** 主键 */
    @Id
    private Long homeNoticeId;

    /** 首页分类（0需求单位首页1采购管理部门首页2采购部首页） */
    @Column(name = "homepage_classification")
    private Integer homepageClassification;

    /** 公告分类（0采购公告1中标公告2流标公告） */
    @Column(name = "announcement_classification")
    private Integer announcementClassification;

    /**
     * 公告名称
     */
    @Column(name = "notice_name")
    private String noticeName;

    /**
     * 公告时间
     */
    @Column(name = "notice_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date noticeTime;

    ///** 合同履行日期 */
    //@Column(name = "performance_date")
    //private String performanceDate;

    /**
     * 采购项目名称
     */
    @Column(name = "project_name")
    private String projectName;
}
