package com.ozs.plan.doman.vo.responseVo;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ozs.common.annotation.Excel;
import com.ozs.system.domain.SysFileRef;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
public class ProvisionalPlanResVo implements Serializable {

    private Long planPracticalId;

    private Long planYearId;

    private String purchaseDeptId;

    @Excel(name = "采购单位")
    private String purchaseDeptName;

    @Excel(name = "项目名称")
    private String projectName;

    private String projectType;
    @Excel(name = "项目类型")
    private String projectTypeStr;

    @Excel(name = "需求概况")
    private String demandOverview;

    @Excel(name = "概算金额（万元）")
    private BigDecimal evaluation;

    private String isExcess;

    private String purchaseServices;
    @Excel(name = "采购服务站")
    private String purchaseServicesStr;
    /**
     * 机关业务指导处(科)
     */
    private String organDivision;
    private String organDivisionStr;
    /**
     * 预算科目
     */
    private String budgetAccount;
    private String budgetAccountStr;

    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date planDemandSubTime;
    @Excel(name = "计划提报需求时间")
    private String planDemandSubTimeStr;

    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date planPurchaseFinishTime;
    @Excel(name = "计划完成采购时间")
    private String planPurchaseFinishTimeStr;

    @JsonFormat(pattern = "yyyy-MM-dd")
    private Date planDeliverTime;
    @Excel(name = "计划交付（实施）时间")
    private String planDeliverTimeStr;

    /**
     * 项目属性
     */
    private String projectAttr;
    @Excel(name = "项目属性")
    private String projectAttrName;
    /**
     * 处理申请撤销
     * 请求根据字段 appDelete 判断，值是true就是已申请
     */
    private String appDelete;
    /**
     * 是否可以申请撤销
     * 请求根据字段 appDeleteDo 判断，值是true就是可以申请
     */
    private String appDeleteDo;
    /**
     * 处理申请修改
     * 请求根据字段 appUpdate 判断，值是true就是已申请
     */
    private String appUpdate;
    /**
     * 是否可以申请修改
     * 请求根据字段 appDeleteDo 判断，值是true就是可以申请
     */
    private String appUpdateDo;

    @Excel(name = "计划调整情况及理由")
    private String adjustReason;

    @Excel(name = "备注")
    private String remarks;

    private String projectStatus;
    @Excel(name = "项目状态")
    private String projectStatusStr;
    private String refuseReason;

    private String delFlay;

    private String planType;

    private String created;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    private String updated;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date updateTime;

    /**
     * 上传附件
     */
    List<SysFileRef> sysFileRefs;

    /**
     * 是否显示审核按钮 （true:显示，false：不显示）
     */
    private Boolean flag;

    /**
     * 是否可以执行发函（true为可以）
     */
    private String sendLetterDo;
    /**
     * 发函状态（0：未发函或已处理，1：确认发函）
     */
    private String sendLetter;
    /**
     * 发函内容
     */
    private String letterStr;

    public ProvisionalPlanResVo() {
    }

    public ProvisionalPlanResVo(Long planPracticalId, String purchaseDeptName, String projectName, String projectTypeStr, String demandOverview, BigDecimal evaluation, String organDivisionStr, String budgetAccountStr, String planDemandSubTimeStr, String planPurchaseFinishTimeStr, String planDeliverTimeStr, String projectAttrName, String remarks) {
        this.planPracticalId = planPracticalId;
        this.purchaseDeptName = purchaseDeptName;
        this.projectName = projectName;
        this.projectTypeStr = projectTypeStr;
        this.demandOverview = demandOverview;
        this.evaluation = evaluation;
        this.organDivisionStr = organDivisionStr;
        this.budgetAccountStr = budgetAccountStr;
        this.planDemandSubTimeStr = planDemandSubTimeStr;
        this.planPurchaseFinishTimeStr = planPurchaseFinishTimeStr;
        this.planDeliverTimeStr = planDeliverTimeStr;
        this.projectAttrName = projectAttrName;
        this.remarks = remarks;
    }
}
