package com.ozs.plan.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.github.pagehelper.PageInfo;
import com.ozs.common.core.domain.AjaxResult;
import com.ozs.common.core.domain.model.LoginUser;
import com.ozs.plan.doman.ProvisionalPlan;
import com.ozs.plan.doman.vo.requestVo.ProvisionalPlanVo;
import com.ozs.plan.doman.vo.responseVo.ProvisionalPlanResVo;

import javax.servlet.http.HttpServletRequest;
import java.text.ParseException;
import java.util.List;

public interface ProvisionalPlanService extends IService<ProvisionalPlan> {
    int deleteProvisionalPlanById(Long planPracticalId);


    int updateProvisionalPlanById(ProvisionalPlanVo provisionalPlan);

    String importProvisionalPlan(List<ProvisionalPlan> provisionalPlans, boolean updateSupport, LoginUser loginUser);

    List<ProvisionalPlanResVo> selectProvisionalPlanExport(ProvisionalPlanVo provisionalPlanVo, LoginUser loginUser);

    int commitProvisionalPlan(ProvisionalPlanVo provisionalPlanVo);

    AjaxResult seletById(Long planPracticalId);

    AjaxResult selectProvisionalPlan(ProvisionalPlanVo provisionalPlanVo, HttpServletRequest request, LoginUser loginUser);

    AjaxResult selectProvisionalPlanAudit(ProvisionalPlanVo provisionalPlanVo, HttpServletRequest request, LoginUser loginUser);

    AjaxResult auditPass(ProvisionalPlanVo provisionalPlanVo);

    AjaxResult auditNoPass(ProvisionalPlanVo provisionalPlanVo);

    List<ProvisionalPlan> queryPage(ProvisionalPlanVo vo) throws ParseException;

    public Integer countYearProjectName(String projectName);

    public Integer countProjectName(String projectName);

    public Integer countProjectNameOth(ProvisionalPlanVo provisionalPlan);

    /**
     * 填写采购服务站
     * @param provisionalPlanVo
     * @return
     */
    AjaxResult adPurchaseServices(ProvisionalPlanVo provisionalPlanVo);
}
