package com.ozs.pm.doman.vo.responseVo;


import com.fasterxml.jackson.annotation.JsonFormat;
import com.ozs.system.domain.SysFileInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;
import java.util.List;


/**
 * 需求建档对象
 *
 * @author ruoyi
 * @date 2023-01-16
 */
@Data
@ApiModel("需求建档对象")
public class PmBookBuildingResVo
{

    @ApiModelProperty("主键")
    private Long id;


    @ApiModelProperty("需求ID")
    private Long demandId;


    @ApiModelProperty("预算金额(万元)")
    private Double budgetAmount;

    @JsonFormat(pattern = "yyyy-MM-dd")
    @ApiModelProperty("需求提报时间")
    private Date demandCommitTime;

    /** 项目类型（0：装备类；1：物资类；2：服务类；3：工程类） */
    @ApiModelProperty("项目类型（0：装备类；1：物资类；2：服务类；3：工程类）")
    private String projectType;

    /** 采购方式  (0:公开招标, 1:单一来源,2:邀请招标,3:竞争式谈判,4:询价) */
    @ApiModelProperty("采购方式  (0:公开招标, 1:单一来源,2:邀请招标,3:竞争式谈判,4:询价)")
    private String purchaseMode;

    @ApiModelProperty("联系人")
    private String contacts;

    @ApiModelProperty("联系电话")
    private String contactPhone;

    @ApiModelProperty("备注")
    private String remarks;


    /**
     * 已上传的关联附件信息
     */
    @ApiModelProperty("已上传的关联附件信息")
    private List<SysFileInfo> fileInfos;


    @ApiModelProperty("创建者")
    private String createBy;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("创建时间")
    private Date createTime;


    @ApiModelProperty("更新者")
    private String updateBy;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("更新时间")
    private Date updateTime;

}
