package com.ozs.pm.doman.vo.responseVo;

import com.ozs.common.annotation.Excel;
import com.ozs.system.domain.SysFileInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * 流程图对象 pm_flow_chart
 *
 * @author ruoyi
 * @date 2023-01-25
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@ApiModel("流程图对象")
public class PmFlowChartResVo
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    @ApiModelProperty("主键")
    private Long flowChartId;

    /** 模块名称 */
    @Excel(name = "模块名称")
    @ApiModelProperty("模块名称")
    private String moduleName;

    /** 部门角色 */
    @Excel(name = "部门角色")
    @ApiModelProperty("部门角色")
    private String deptRole;

    /** 提示文案 */
    @Excel(name = "提示文案")
    @ApiModelProperty("提示文案")
    private String promptWords;


    /**
     * 已上传的关联附件信息
     */
    @ApiModelProperty("已上传的关联附件信息")
    private List<SysFileInfo> fileInfos;
}
