package com.ozs.pm.doman.vo.responseVo;



import com.ozs.base.domain.BaseAgency;
import com.ozs.system.domain.SysFileInfo;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;


import java.util.Date;
import java.util.List;


/**
 * 中标信息对象
 *
 * @author ruoyi
 * @date 2023-01-16
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@ApiModel("中标信息对象")
public class PmPurchaseExecutionResVo {
    /** 采购需求ID */
    @ApiModelProperty("采购需求ID")
    private Long demandId;

    @ApiModelProperty("招标代理机构信息")
    private BaseAgency baseAgency;

    @ApiModelProperty("专家意见反馈信息")
    private PmExpertFeedbackResVo pmExpertFeedbackResVo;

    @ApiModelProperty("采购文件编制审核信息")
    private PmProcurementDocumentsReviewResVo pmProcurementDocumentsReviewResVo;

    @ApiModelProperty("采购公告列表")
    private List<PmReleaseAnnouncementResVo> pmReleaseAnnouncementResVoList;

    @ApiModelProperty("采购公告附件")
    private List<SysFileInfo> pmReleaseAnnouncementFileInfos;

    @ApiModelProperty("标前质疑投诉列表")
    private List<PmCallQuestionResVo> pmCallQuestionPreResVoList;
    @ApiModelProperty("标前质疑投诉附件")
    private List<SysFileInfo> pmCallQuestionPreFileInfos;


    @ApiModelProperty("专家列表")
    private List<PmBaseExpertResVo> pmBaseExpertResVoList;

    @ApiModelProperty("开标信息列表")
    private List<PmBidOpeningResVo> pmBidOpeningResVoList;

    @ApiModelProperty("评标结果公告列表")
    private List<PmBidWinningResVo> pmBidWinningResVoList;
    @ApiModelProperty("评标结果公告附件")
    private List<SysFileInfo> pmBidWinningFileInfos;

    @ApiModelProperty("标后质疑列表")
    private List<PmCallQuestionResVo> pmCallQuestionPostResVoList;
    @ApiModelProperty("标后质疑情况附件")
    private List<SysFileInfo> pmCallRequestPostFileInfos;


    @ApiModelProperty("流标信息列表")
    private List<PmBidFailureResVo> pmBidFailureResVoList;
    @ApiModelProperty("流标信息附件")
    private List<SysFileInfo> pmBidFailureFileInfos;

    @ApiModelProperty("流废标处置-质疑列表")
    private List<PmCallQuestionResVo> pmCallQuestionBidFailureResVoList;
    @ApiModelProperty("流废标处置-质疑情况附件")
    private List<SysFileInfo> pmCallRequestBidFailureFileInfos;

    /**
     * 中标通知书
     */
    @ApiModelProperty("中标通知书")
    private List<SysFileInfo> fileInfos;
    @ApiModelProperty("上传中标通知书时间")
    private Date upAcceptanceTime;
}
